package com.example.eatwell.view

import android.util.Log
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.example.eatwell.Resources
import com.example.eatwell.domain.Constant
import com.example.eatwell.model.Category
import com.example.eatwell.model.Diets
import com.example.eatwell.model.Dish
import com.example.eatwell.model.Fridge
import com.example.eatwell.model.Ingredients
import com.example.eatwell.model.Recipes

import io.github.jan.supabase.gotrue.auth
import io.github.jan.supabase.gotrue.providers.builtin.Email
import io.github.jan.supabase.postgrest.from
import kotlinx.coroutines.launch
import java.util.UUID

class MainViewModel():ViewModel() {

    fun onSignInEmailPassword(emailUser: String, passwordUser: String) {
        viewModelScope.launch {
            try {
                //   Constant.supabase.auth.signOut()
                val user = Constant.supabase.auth.signInWith(Email) {
                    email = emailUser
                    password = passwordUser
                }


                //  println(user.toString())
                Log.d("Логин: ", user.toString())
                // println(Constant.supabase.auth.currentUserOrNull()!!.id)
                println("Success")
                Log.d("Логин",Constant.supabase.auth.currentUserOrNull()!!.id )
            } catch (e: Exception) {

                Log.d("Ошибка а: ", e.message.toString())
                println(e.message.toString())
            }
        }
    }
    fun onSignUpEmail(emailUser: String, passwordUser: String) {
        viewModelScope.launch {
            try{
                var  user =  Constant.supabase.auth.signUpWith(Email) {
                    email = emailUser
                    password = passwordUser
                }
                println(user.toString())
                println(Constant.supabase.auth.currentUserOrNull()!!.id)
                println("Success")

            }
            catch (e: Exception) {
                println("Error")
                println(e.message.toString())
            }

        }
    }

    fun addIngredientToFridge(ingredientId: Int) {
        viewModelScope.launch {
            val userId = UUID.fromString(Constant.supabase.auth.currentUserOrNull()!!.id)
            val fridgeItem = Fridge(
                ingredients = ingredientId,
                user_id = userId.toString()
            )

            Log.d("Идентификатор: ", Constant.supabase.auth.currentUserOrNull()!!.id );
            try {
                val response = Constant.supabase
                    .from("Fridge")
                    .insert(Fridge(ingredients = ingredientId, user_id = Constant.supabase.auth.currentUserOrNull()!!.id ))
                // .execute()
                Log.d("Ответ вставки: ", response.toString())
            }
            catch (ex: Exception){
                Log.d("Ошибка вставки: ", ex.toString())
            }
        }
    }

    fun getRecipes(){

        viewModelScope.launch {
            try {
                Resources.recipes = Constant.supabase.from("Recipes").select { "*" }
                    .decodeList<Recipes>() as ArrayList<Recipes>
                Log.d("Список: ", " " + Resources.recipes)
            } catch (e: Exception) {
                Log.e("Ошибка р: ", e.message.toString())
            }
        }
    }

    fun getDishes(){

        viewModelScope.launch {
            try {
                Resources.dishes = Constant.supabase.from("Dish").select{
                    "*"
                }.decodeList<Dish>() as ArrayList<Dish>

                Log.d("Блюда: ",  Resources.dishes.toString())
            } catch (e: Exception) {
                Log.e("Ошибка б: ", e.message.toString())
            }
        }
    }

    fun deleteIngredient(ingredientId: Int) {

        viewModelScope.launch {
            try {
                Constant.supabase.from("Fridge").delete{
                    filter {
                        Fridge::user_id eq Constant.supabase.auth.currentUserOrNull()!!.id
                        Fridge::ingredients eq ingredientId
                    }
                }

                var list = Constant.supabase.from("Fridge")
                    .select().decodeList<Fridge>()
                //   getFridge()

                Log.d("Список продуктов: ", list.toString())
            } catch (e: Exception) {
                Log.e("Ошибка продукты: ", e.message.toString())
            }
        }
    }

    fun getFridge(){
        viewModelScope.launch {

            try {
                var list =  Constant.supabase.from("Fridge").select() {
                    filter {
                        Fridge::user_id eq Constant.supabase.auth.currentUserOrNull()!!.id
                    }
                }.decodeList<Fridge>()

                Log.d("id ", Constant.supabase.auth.currentUserOrNull()!!.id )
                Log.d("fridge: ", list.toString())

                Resources.chosenIngredients.clear();
                for (i in 0..list.size-1){
                    for (j in 0..Resources.ingredients.size-1){
                        if(Resources.ingredients.get(j).id == list.get(i).ingredients){
                            Resources.chosenIngredients.add(Resources.ingredients.get(j))
                            break
                        }

                    }
                }


            } catch (e: Exception) {
                Log.e("Ошибка х: ", e.message.toString())
            }
        }
    }


    fun getRecipes(categoryId: Int, dietId: Int): List<Recipes>{
        var recipesList: List<Recipes>
        recipesList = ArrayList()
        viewModelScope.launch {
            try{
                recipesList = Constant.supabase.from("Recipes").select(){ filter {

                    Recipes::category eq categoryId
                    Recipes::diets eq dietId
                } }.decodeList<Recipes>()
                Log.d("Список по категории: ", recipesList.toString())
            }
            catch (e: Exception){
                Log.e("Ошибка р: ", e.message.toString())
            }
        }
        return recipesList;
    }

    fun getDiets(){
        viewModelScope.launch {
            try{
                Resources.diets = Constant.supabase.from("Diets").select { "*" }.decodeList<Diets>() as ArrayList<Diets>
                Log.d("Диеты: ", Resources.diets.toString())
            }
            catch (e: Exception){
                Log.e("Ошибка д: ", e.message.toString())
            }
        }

    }

    fun getCategory(){
        viewModelScope.launch {
            try{
                Resources.categories = Constant.supabase.from("Category").select { "*" }.
                decodeList<Category>() as ArrayList<Category>
                Log.d("Категория: ", Resources.categories.toString())
            }
            catch (e: Exception){
                Log.e("Ошибка к:  ", e.message.toString())
            }
        }
    }

    fun getIngredients(){
        viewModelScope.launch {
            try{
                Resources.ingredients = Constant.supabase.from("Ingredients").select { "*" }.
                decodeList<Ingredients>() as ArrayList<Ingredients>
                Log.d("Инградиенты: ", Resources.ingredients.toString())
            }
            catch (e: Exception){
                Log.e("Ошибка и: ", e.message.toString())
            }
        }

    }
}