package com.example.eatwell.view.mainActivity

import android.util.Log
import androidx.compose.foundation.Image
import androidx.compose.foundation.background
import androidx.compose.foundation.layout.Box
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.height
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.layout.width
import androidx.compose.foundation.shape.RoundedCornerShape
import androidx.compose.material3.ExperimentalMaterial3Api
import androidx.compose.runtime.Composable
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.draw.clip
import androidx.compose.ui.tooling.preview.Preview
import androidx.compose.ui.unit.dp
import com.example.eatwell.view.ui.theme.fon
import com.example.eatwell.view.ui.theme.white
import androidx.compose.foundation.clickable
import androidx.compose.foundation.layout.*
import androidx.compose.foundation.lazy.LazyColumn
import androidx.compose.foundation.lazy.items
import androidx.compose.material.*
import androidx.compose.material.icons.Icons
import androidx.compose.material.icons.filled.ArrowDropDown
import androidx.compose.material.icons.filled.DateRange
import androidx.compose.material.icons.filled.Home
import androidx.compose.material.icons.filled.Lock
import androidx.compose.material.icons.filled.ShoppingCart
import androidx.compose.material3.Button
import androidx.compose.material3.ButtonDefaults
import androidx.compose.material3.Divider
import androidx.compose.material3.DropdownMenu
import androidx.compose.material3.DropdownMenuItem
import androidx.compose.runtime.*
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.text.font.FontWeight
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import androidx.compose.material3.Text
import androidx.compose.material3.Icon
import androidx.compose.material3.IconButton
import androidx.compose.ui.graphics.vector.ImageVector
import androidx.compose.ui.platform.LocalContext
import androidx.compose.ui.res.painterResource
import androidx.compose.ui.res.vectorResource
import androidx.compose.ui.text.font.FontFamily
import androidx.compose.ui.text.style.TextAlign
import androidx.navigation.NavController
import coil.compose.rememberImagePainter
import com.example.eatwell.R
import com.example.eatwell.Resources
import com.example.eatwell.domain.Constant
import com.example.eatwell.model.Recipes
import com.example.eatwell.view.ui.theme.black
import com.example.eatwell.view.ui.theme.fon2
import com.example.eatwell.view.ui.theme.knopka
import com.example.eatwell.view.ui.theme.text_1
import io.github.jan.supabase.gotrue.auth

@OptIn(ExperimentalMaterial3Api::class)
//@Preview
@Composable
fun dish(navController: NavController) {
    // фильтруем и добавляем рецепты в списов лист
    var list = remember { mutableStateListOf<Recipes>() }
    for (j in 0..Resources.dishes.size-1) { // проходимся по списку блю и рецептов
        for (i in 0..Resources.recipes.size - 1) {
            if(Resources.dishes.get(j).recipes == Resources.recipes.get(i).id && //проверяем совпадает ли айди пользователя в списке диш с текущем польхователем
                Resources.dishes.get(j).user_id == Constant.supabase.auth.currentUserOrNull()!!.id) {

                list.add(Resources.recipes.get(i)) // добав в список лист
            }
        }
    }

    Log.d("Рецепты: ", list.toString())
    Box(
        modifier = Modifier
            .fillMaxSize()
            .background(fon)
    ) {
        Box(
            modifier = Modifier
                .fillMaxSize()
                .background(fon)
        )
        Box(
            modifier = Modifier
                .width(359.dp)
                .height(800.dp)
                .clip(RoundedCornerShape(30.dp))
                .background(white)
                .align(Alignment.Center) //   .shadow(elevation = 10.dp, shape = RoundedCornerShape(30.dp))
                .padding(16.dp)


        ) {
            Column(
                modifier = Modifier
                    .fillMaxSize()
                    .background(white)
                    .padding(top = 10.dp, start = 15.dp, end = 15.dp)
            ) {
                Text(
                    text = "Подходящие Рецепты",
                    fontSize = 20.sp,
                    fontWeight = FontWeight.Bold,
                    color = black,
                    textAlign = TextAlign.Center,
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(bottom = 15.dp)
                )
                Box(
                    modifier = Modifier
                        .width(359.dp)
                        .height(550.dp)
                        .clip(RoundedCornerShape(30.dp))
                        .background(fon2)
                        .padding(15.dp)

                ) {
                    Column(
                        modifier = Modifier
                            .size(width = 400.dp, height = 750.dp)
                            .background(fon2)

                    ) {

                        LazyColumn(
                            modifier = Modifier.fillMaxSize()
                        ) {

                            items(list.size) { itemId -> // определяем количество элементов itemId это индекс элемента в списке
                                Image(
                                    painter = rememberImagePainter(
                                        list.get(
                                            itemId
                                        ).image
                                    ),
                                    contentDescription = "Image - $itemId",
                                    modifier = Modifier
                                        .padding(
                                            top = 10.dp,
                                            bottom = 10.dp,
                                            start = 7.5.dp,
                                            end = 7.5.dp
                                        )
                                        .fillMaxWidth()
                                        .height(150.dp)
                                        .clip(RoundedCornerShape(50.dp))
                                )
                                Text(
                                    modifier = Modifier
                                        .fillMaxWidth()
                                        .padding(top = 7.5.dp),
                                    text = list.get(itemId).name,
                                    color = Color.Black,
                                    fontSize = 20.sp,
                                    fontWeight = FontWeight.Bold,
                                    fontFamily = FontFamily.Monospace,
                                    textAlign = TextAlign.Left

                                )


                                Text(
                                    modifier = Modifier
                                        .fillMaxWidth()
                                        .padding(top = 7.5.dp),
                                    text = list.get(itemId).calories,
                                    color = knopka,
                                    fontSize = 15.sp,
                                    fontWeight = FontWeight.Bold,
                                    fontFamily = FontFamily.Monospace,
                                    textAlign = TextAlign.Left
                                )
                                Text(
                                    modifier = Modifier
                                        .fillMaxWidth()
                                        .padding(top = 7.5.dp),
                                    text = list.get(itemId).description,
                                    color = knopka,
                                    fontSize = 15.sp,
                                    fontWeight = FontWeight.Bold,
                                    fontFamily = FontFamily.Monospace,
                                    textAlign = TextAlign.Left
                                )
                            }
                        }
                    }

                }

                Button(
                    onClick = {

                        navController.navigate("fridge")
                    }, Modifier
                        .fillMaxWidth()
                        .padding(vertical = 8.dp, horizontal = 1.dp)
                        .height(55.dp)
                        .background(Color.Transparent),
                    shape = RoundedCornerShape(20.dp),


                    colors = ButtonDefaults.buttonColors(containerColor = knopka)
                ) {
                    Text(
                        "Назад",
                        fontSize = 20.sp,
                        color = white,
                        fontWeight = FontWeight.SemiBold
                    )
                }
                Column(
                    modifier = Modifier
                        .fillMaxSize()
                        .background(white)
                        .padding(top = 20.dp, start = 15.dp, end = 15.dp)
                ) {
                    Box(
                        modifier = Modifier
                            .fillMaxWidth()
                            .padding(bottom = 1.dp)
                    ) {
                        Divider(
                            modifier = Modifier
                                .fillMaxWidth()
                                .height(1.dp)
                                .background(fon)
                        )
                        Row(
                            modifier = Modifier
                                .fillMaxWidth()
                                .padding(top = 8.dp),
                            horizontalArrangement = Arrangement.SpaceBetween,
                            verticalAlignment = Alignment.CenterVertically
                        ) {

                            Column(
                                horizontalAlignment = Alignment.CenterHorizontally
                            ) {
                                IconButton(
                                    onClick = {
                                        navController.navigate("Home")
                                        {
                                        }
                                    }, modifier = Modifier.size(32.dp)
                                ) {
                                    Icon(
                                        painter = painterResource(id = R.drawable.img),
                                        contentDescription = "HOME",
                                        tint = text_1,
                                        modifier = Modifier.size(25.dp)
                                    )
                                }
                                Spacer(modifier = Modifier.height(4.dp))
                                Text("HOME", color = text_1)
                            }
                            Column(
                                horizontalAlignment = Alignment.CenterHorizontally
                            ) {
                                IconButton(
                                    onClick = {
                                        navController.navigate("MyPlan")
                                        {
                                        }
                                    }, modifier = Modifier.size(32.dp)
                                ) {
                                    Icon(
                                        painter = painterResource(id = R.drawable.img_1),
                                        contentDescription = "My Plan",
                                        tint = text_1,
                                        modifier = Modifier.size(25.dp)
                                    )
                                }
                                Spacer(modifier = Modifier.height(9.dp))
                                Text("MY PLAN", color = text_1)
                            }
                            Column(
                                horizontalAlignment = Alignment.CenterHorizontally
                            ) {
                                Icon(
                                    painter = painterResource(id = R.drawable.img_4),
                                    contentDescription = "Fridge",
                                    tint = Color.Black
                                )
                                Spacer(modifier = Modifier.height(4.dp))
                                Text("FRIGE", color = Color.Black)
                            }

                            Column(
                                horizontalAlignment = Alignment.CenterHorizontally
                            ) {
                                IconButton(
                                    onClick = {
                                        navController.navigate("Auth")
                                        {
                                        }
                                    }, modifier = Modifier.size(32.dp)
                                ) {
                                    Icon(
                                        painter = painterResource(id = R.drawable.img_3),
                                        contentDescription = "Log Out",
                                        tint = text_1,
                                        modifier = Modifier.size(28.dp)
                                    )
                                }
                                Spacer(modifier = Modifier.height(9.dp))
                                Text("LOG OUT", color = text_1)
                            }
                        }
                    }
                }
            }
        }
    }
}
